Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC

Bug 574034 (CVE-2016-2194, CVE-2016-2195)

Summary: <dev-libs/botan-{1.10.12,1.11.28}: Multiple vulnerabilities (CVE-2016-{2194,2195})
Product: Gentoo Security Reporter: Jack Lloyd <lloyd>
Component: VulnerabilitiesAssignee: Gentoo Security <security>
Status: RESOLVED FIXED    
Severity: normal CC: alonbl, crypto+disabled, proxy-maint
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
URL: http://botan.randombit.net/security.html
Whiteboard: B2 [glsa cve]
Package list:
Runtime testing required: ---

Description Jack Lloyd 2016-02-06 19:45:05 UTC
Hi,

Botan 1.11.28 and 1.10.12 were released fixing several serious security bugs including a heap overflow.

http://botan.randombit.net/releases/Botan-1.11.28.tgz
SHA-256 a414c96f45b2707d4750d299ca03ec3fce5ada62ada1ba5cd012a9ace61f5932

http://botan.randombit.net/releases/Botan-1.10.12.tgz
SHA-256 affc3a79919577943f896e64d3e4a4dcc4970c5bf80cc98c7f3a3144745eac27

I am listed as the maintainer for this ebuild but don't use Gentoo much anymore (I still like it, but it can be time consuming to maintain...) so cannot provide an update. I don't believe there are any build related changes that affect an upgrade vs the current ebuilds.
Comment 1 Alon Bar-Lev gentoo-dev 2016-02-07 16:57:03 UTC
Added, thanks!
Comment 2 Kristian Fiskerstrand gentoo-dev Security 2016-02-07 17:49:54 UTC
libbotan 1.11 is masked so only tracking the security issues in 1.10-series

2016-02-01 (CVE-2016-2195): Heap overflow on invalid ECC point

The PointGFp constructor did not check that the affine coordinate arguments were less than the prime, but then in curve multiplication assumed that both arguments if multiplied would fit into an integer twice the size of the prime.

The bigint_mul and bigint_sqr functions received the size of the output buffer, but only used it to dispatch to a faster algorithm in cases where there was sufficient output space to call an unrolled multiplication function.

The result is a heap overflow accessible via ECC point decoding, which accepted untrusted inputs. This is likely exploitable for remote code execution.

On systems which use the mlock pool allocator, it would allow an attacker to overwrite memory held in secure_vector objects. After this point the write will hit the guard page at the end of the mmap’ed region so it probably could not be used for code execution directly, but would allow overwriting adjacent key material.

Found by Alex Gaynor fuzzing with AFL

Introduced in 1.9.18, fixed in 1.11.27 and 1.10.11

######
2016-02-01 (CVE-2016-2194): Infinite loop in modulur square root algorithm

The ressol function implements the Tonelli-Shanks algorithm for finding square roots could be sent into a nearly infinite loop due to a misplaced conditional check. This could occur if a composite modulus is provided, as this algorithm is only defined for primes. This function is exposed to attacker controlled input via the OS2ECP function during ECC point decompression. Found by AFL

Introduced in 1.7.15, fixed in 1.11.27 and 1.10.11
Comment 3 Kristian Fiskerstrand gentoo-dev Security 2016-02-07 17:51:55 UTC
Arches, please stabilize:
=dev-libs/botan-1.10.12
Stable targets: amd64 hppa ppc ppc64 sparc x86
Comment 4 Agostino Sarubbo gentoo-dev 2016-02-11 12:28:14 UTC
amd64 stable
Comment 5 Jeroen Roovers gentoo-dev 2016-02-12 07:24:25 UTC
Stable for HPPA PPC64.
Comment 6 Agostino Sarubbo gentoo-dev 2016-03-15 17:00:52 UTC
x86 stable
Comment 7 Agostino Sarubbo gentoo-dev 2016-03-16 14:10:19 UTC
ppc stable
Comment 8 Agostino Sarubbo gentoo-dev 2016-03-19 12:29:52 UTC
sparc stable.

Maintainer(s), please cleanup.
Security, please add it to the existing request, or file a new one.
Comment 9 Alon Bar-Lev gentoo-dev 2016-03-19 18:42:21 UTC
(In reply to Agostino Sarubbo from comment #8)
> Maintainer(s), please cleanup.

Done, thanks!
Comment 10 Thomas Deutschmann gentoo-dev Security 2016-11-29 22:25:26 UTC
New GLSA created.
Comment 11 GLSAMaker/CVETool Bot gentoo-dev 2016-12-13 06:52:47 UTC
This issue was resolved and addressed in
 GLSA 201612-38 at https://security.gentoo.org/glsa/201612-38
by GLSA coordinator Aaron Bauman (b-man).